// Header File
// Created 6/24/2005; 9:25:28 PM

//This function (ShowImg) is based off of code from a TICT tutorial.
//ShowImg useful for displaying large pictures or full screen displays
//It is modified from its original version by William M Hilton
//The original author was:
	/******************************************************************************
	*                                                                             
	* T I C T   T U T O R I A L S                                                 
	*                                                                                                                                                         
	* Executive Editor: thomas.nussbaumer@gmx.net                                 
	* Homepage:         http://go.to/tichess                                      
	*                                                                                                                                                          
	* ----------------------------------------------------------------------------- 
	*                                                                                                                                                                                                                                       
	* SERIES 1 - Basic Techniques                                                 
	*                                                                             
	* PART I: Handling Uncompressed Images in C-Projects  v 1.00                  
	*
	*
	* Release Date: 14/08/2000                                                    
	******************************************************************************/

#define USE_GRAY_PATCH   // use grayscale patch

/*---------------------------------------------------------------------------*/
/* includes (NOTE: I don't use all.h, but include just the necessary files)  */
/*---------------------------------------------------------------------------*/
//#include <nostub.h>      // necessary for the nostub stuff
//#include <graph.h>       // for LCD_WIDTH definition
//#include <compat.h>      // for the TI89 definition
#include <mem.h>         // for memset() and memcpy()

void ShowImg(short x, short y, short width, short height, 
							unsigned char *image1, unsigned char *image2) {

    unsigned char* plane1;
    unsigned char* plane2;
    unsigned char* dest1;
    unsigned char* dest2;
    unsigned char* src1;
    unsigned char* src2;
    int            loop;

    //-----------------------------------------------
    // fetch start addresses of planes
    //-----------------------------------------------
    plane1 = GetPlane(0);
    plane2 = GetPlane(1);

    dest1 = plane1;
    dest2 = plane2;
    src1  = image1;
    src2  = image2;
		
	/****Uncomment this part if you want to center the printout on*****
	*****a TI92 or Voyager. Otherwise, x and y will be relative   *****
	*****from the top left corner of the screen                   *****
		//-----------------------------------------------
    // on the TI92 we have to clear both bitplanes
    // because the skipped parts will be visible
    //
    // additionally we have to add an initial offset
    // to the destination pointers
    //-----------------------------------------------
    if (!TI89) {
        memset(plane1,0,LCD_SIZE);
        memset(plane2,0,LCD_SIZE);

        //-------------------------------------------
        // setup the destination pointers taking the 
        // initial offset into account
        // (each line consists of 30 bytes on a TI92)
        //-------------------------------------------
        dest1 += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2 += ((128-100)*30)/2 + ((240-160)/8)/2;
    }
	*****                                                         *****
	*****                                                         ****/
	
    //-----------------------------------------------
    // ... and now copy all lines from the data 
    // arrays to the bitplanes
    //-----------------------------------------------
    for (loop=0;loop<height;loop++,src1+=width/8,src2+=width/8,dest1+=30,dest2+=30) {
        memcpy(dest1+y*30+x/8,src1,width/8);
        memcpy(dest2+y*30+x/8,src2,width/8);
    }
}