VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   0  'None
   Caption         =   "BMP-2-TIC"
   ClientHeight    =   945
   ClientLeft      =   105
   ClientTop       =   105
   ClientWidth     =   975
   Icon            =   "img2TIC.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   945
   ScaleWidth      =   975
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin VB.PictureBox picBox 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   720
      Left            =   120
      ScaleHeight     =   46
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   46
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   720
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'REQUIREMENTS:
'Filenames must be specified in the Command Line in double quotes
'   - GetNextFile
'Image widths must be divisible by eight. (Smallest hex character is 'char'
'   which has two hex digits, e.g. eight bits)
'   - WriteToFile
'The RBG values of four-color image should be 0, 85, 170, and 255
'   - LoadBits

Option Explicit 'Declare all variables
Option Base 1   'Array indeces start at 1, not 0
                '(the reason for this becomes clear later)
Dim fso As New FileSystemObject 'Useful for file name parsing
Dim strCommandLine As String    'The Command Line input
Dim aryBin1() As Byte 'Layer 1 bit
Dim aryBin2() As Byte 'Layer 2 bit
Dim aryHex1() As Integer 'Layer 1 hex values
Dim aryHex2() As Integer 'Layer 2 hex values
Dim strSpriteType As String '8, 16, 32, custom
Dim ImgHeight As Integer    'Width of the image
Dim ImgWidth As Integer     'Height of the image
Dim IsGreyScale As Boolean  'True if greyscale image

Private Sub Form_Load()
    
    Dim strFile As String
    strCommandLine = Command 'Load the Command Line string
    If strCommandLine = "" Then
        MsgBox "Drag and drop image files onto the desktop icon to use this program."
        End
    End If
    '(picBox is a PictureBox control)
    picBox.AutoSize = True
    picBox.Appearance = 0 'Flat
    
    Do While Not strCommandLine = ""
        IsGreyScale = False
        strFile = GetNextFile()
        LoadBits (strFile)
        ConvertToHex
        WriteToFile (strFile)
    Loop
    'Copy ShowImg.h to the the same folder as the other C file
    If Not fso.FileExists(fso.GetParentFolderName(strFile) & "\ShowImg.h") Then
        fso.CopyFile App.Path & "\" & "ShowImg.h", fso.GetParentFolderName(strFile) & "\ShowImg.h", False
    End If
    End 'End the program
End Sub

Private Function GetNextFile()
    Dim index As Long
    'Chr(34) is a double quote (")
    
    If Not Left(strCommandLine, 1) = Chr(34) Then
        MsgBox "Filenames must be inclosed in double quotes (" & Chr(34) & ")"
        End
    Else
        index = InStr(2, strCommandLine, Chr(34))
        GetNextFile = Mid(strCommandLine, 2, index - 2)
        strCommandLine = Mid(strCommandLine, index + 2)
    End If
End Function

Private Sub LoadBits(strFile)

'Load the picture
picBox.Picture = LoadPicture(strFile)

ImgHeight = picBox.ScaleHeight:    ImgWidth = picBox.ScaleWidth

frmMain.Refresh 'Cause the picBox to update its display memory

ReDim aryBin1(ImgWidth * ImgHeight) '(1 bit for each pixel)
ReDim aryBin2(ImgWidth * ImgHeight) '(1 bit for each pixel)

Select Case ImgWidth
    Case 8:  strSpriteType = "8"
    Case 16: strSpriteType = "16"
    Case 32: strSpriteType = "32"
    Case Else: strSpriteType = "other"
End Select

MsgBox "Img2TIC - " & fso.GetFileName(strFile) & vbCrLf & _
    "Dimensions: " & ImgWidth & " by " & ImgHeight & vbCrLf & _
    "SpriteType: " & strSpriteType

If Not ImgWidth Mod 8 = 0 Then
    MsgBox "Image Width must be evenly divisible by 8 for program to work properly." & vbCrLf & _
        "Please resize your image."
    End
End If

Dim X As Integer, Y As Integer, i As Integer  'counter
i = 1

For Y = 1 To ImgHeight Step 1
    For X = 1 To ImgWidth Step 1
        Select Case picBox.Point(X - 1, Y - 1) 'ReturnRGB( ,2)
            Case 0
                'MsgBox "black"
                aryBin1(i) = 1: aryBin2(i) = 1
            Case 5592405 '85
                'MsgBox "dark grey"
                Debug.Print "Dark Grey " & picBox.Point(X - 1, Y - 1)
                aryBin1(i) = 0: aryBin2(i) = 1
                IsGreyScale = True
            Case 11184810 '170
                'MsgBox "light grey"
                Debug.Print "Light Grey " & picBox.Point(X - 1, Y - 1)
                aryBin1(i) = 1: aryBin2(i) = 0
                IsGreyScale = True
            Case 255
                'MsgBox "white"
                aryBin1(i) = 0: aryBin2(i) = 0
        End Select
        i = i + 1
    Next X
Next Y

End Sub

Private Sub ConvertToHex()
    'i counts bits, d counts digits, h counts hex values
    Dim i As Integer, d As Byte, h As Integer
    
    'aryHex is 1/4th the size of aryBin
    ReDim aryHex1(UBound(aryBin1) / 4): ReDim aryHex2(UBound(aryBin2) / 4)
    aryHex1(1) = 0: aryHex2(1) = 0
    d = 1:  h = 1

    'Load the bit arrays into hex arrays (4 bits per hex value)
    For i = 1 To UBound(aryBin1) Step 1
        aryHex1(h) = aryHex1(h) * 2 + aryBin1(i)
        aryHex2(h) = aryHex2(h) * 2 + aryBin2(i)
        d = d + 1
        If d = 5 Then d = 1: h = h + 1
    Next i
    
End Sub

Private Sub WriteToFile(strFile)
    
    'Declare variables
    Dim intFile As Long 'File Handel
    Dim strString As String, strLine As String 'a word and a sentence, respectively
    Dim intWordWrap As Integer, intLineWrap As Integer
    'b = counts bits, d counts hex digits, h counts hex "words"
    Dim b As Integer, d As Integer, h As Integer
    Dim strCFile As String 'Name of created C File
    Dim strSpriteName As String
    
    intFile = FreeFile()
    strCFile = Left(strFile, Len(strFile) - 3) & "h" 'A C header file
    strSpriteName = fso.GetBaseName(strFile) 'ExtractName(strFile)
    
    'THIS DETERMINES A LOT OF STUFF.
    Select Case strSpriteType
        Case "8"
            intWordWrap = 2 '2 hex characters per word
            intLineWrap = 8 '8 hex words per line
        Case "16"
            intWordWrap = 4 '4 hex characters per word
            intLineWrap = 8 '8 hex words per line
        Case "32"
            intWordWrap = 8 '8 hex characters per word
            intLineWrap = 4 '4 hex words per line
        Case "other"
            intWordWrap = 2 '2 hex characters per word
            intLineWrap = ImgWidth / 8 'Newlines correspond to ImgWidth
    End Select
    
    
    'Open the output file for output.
    Open strCFile For Output As #intFile
        
    'Output all the required information.
    Print #intFile, "//Image data created by Img2TIC 1.0 Beta (William M. Hilton)"
    Print #intFile, "#define " & UCase(strSpriteName) & "_WIDTH " & ImgWidth
    Print #intFile, "#define " & UCase(strSpriteName) & "_HEIGHT " & ImgHeight
    Print #intFile, ""
    Print #intFile, "// " & strSpriteName & " --- bitplane 1"
    Print #intFile, "unsigned " & IIf(intWordWrap = 2, "char ", "") & _
                                IIf(intWordWrap = 4, "short int ", "") & _
                                IIf(intWordWrap = 8, "long int ", "") & _
                                strSpriteName & IIf(IsGreyScale, "1", "") & "[] = {"
    strLine = "": strString = ""
    d = 0: h = 0
    'Output hex values in correct format for its sprite type
    For b = 1 To UBound(aryHex1) Step 1
        'Concatenate hex character
        strString = strString & Hex(aryHex1(b))
        d = d + 1
        'Handle "word" syntax
        If d = intWordWrap Then
            'The IIf function returns "}" instead of "," if
            'this is the last bit
            strLine = strLine & "0x" & strString & _
                IIf(b = UBound(aryHex1), "};", ",")
                'Debug.Print "d=" & d & " h=" & h & " " & strLine
            strString = "": d = 0: h = h + 1
        End If
        'Handle "sentence" syntax
        If h = intLineWrap Or b = UBound(aryHex1) Then
            Print #intFile, vbTab & strLine
            strString = "": strLine = "": h = 0
        End If
    Next b
    
    If IsGreyScale Then
        'Output all the required information.
        Print #intFile, "", ""
        Print #intFile, "// " & strSpriteName & " --- bitplane 2"
        Print #intFile, "unsigned " & IIf(intWordWrap = 2, "char ", "") & _
                                    IIf(intWordWrap = 4, "short int ", "") & _
                                    IIf(intWordWrap = 8, "long int ", "") & _
                                    strSpriteName & "2[] = {"
        strLine = "": strString = ""
        d = 0: h = 0
        'Output hex values in correct format for its sprite type
        For b = 1 To UBound(aryHex2) Step 1
            'Concatenate hex character
            strString = strString & Hex(aryHex2(b))
            d = d + 1
            'Handle "word" syntax
            If d = intWordWrap Then
                'The IIf function returns "}" instead of "," if
                'this is the last bit
                strLine = strLine & "0x" & strString & _
                    IIf(b = UBound(aryHex2), "};", ",")
                    'Debug.Print "d=" & d & " h=" & h & " " & strLine
                strString = "": d = 0: h = h + 1
            End If
            'Handle "sentence" syntax
            If h = intLineWrap Or b = UBound(aryHex2) Then
                Print #intFile, vbTab & strLine
                strString = "": strLine = "": h = 0
            End If
        Next b
    End If
    
    Close #intFile
    
    'Open the finished file in Notepad
    'Shell "Notepad " & strCFile, vbMaximizedFocus

End Sub
